---
- include_tasks: prepare_docker_env.yml

# - name: Install Docker Engine
#   block:
#     - name: Install Docker and related packages
#       apt:
#         name:
#           - docker-ce
#           - docker-ce-cli
#           - containerd.io
#           - docker-buildx-plugin
#           - docker-compose-plugin
#         state: present
#       notify: "enable and start docker"

- name: Install Docker Engine using the convenience script
  block:
    - name: Add Docker GPG key
      apt_key:
        url: https://download.docker.com/linux/ubuntu/gpg
        state: present

    - name: Download and verify Docker installation script
      get_url:
        url: https://get.docker.com
        dest: /tmp/get-docker.sh
        checksum: 'sha256:91812e1d2fa1319d5f013e4edccca7e03c87fe89e61b82423217a3f13e7d9034'
      register: download_result

    - name: Run Docker install script with dry-run
      command: sh /tmp/get-docker.sh --dry-run
      register: dry_run_result
      failed_when: dry_run_result.rc != 0

    - name: Run Docker install script
      command: sh /tmp/get-docker.sh
      when: dry_run_result.rc == 0
      notify: Remove downloaded script

  # rescue:
  #   - name: Log failure and clean up
  #     debug:
  #       msg: "Installation failed, cleaning up."
  #     notify: Remove downloaded script

- name: Configure Docker daemon
  copy:
    content: |
      {
        "exec-opts": ["native.cgroupdriver=systemd"],
        "log-driver": "json-file",
        "log-opts": {
          "max-size": "50m",
          "max-file": "3"
        },
        "storage-driver": "overlay2"
      }
    dest: /etc/docker/daemon.json
  notify: "Restart Docker service"
